package io.github.drumber.kitsune.domain.mapper

import io.github.drumber.kitsune.domain.model.database.LocalAnime
import io.github.drumber.kitsune.domain.model.infrastructure.media.Anime

fun Anime.toLocalAnime() = LocalAnime(
    id = id,
    slug = slug,
    description = description,
    titles = titles,
    canonicalTitle = canonicalTitle,
    abbreviatedTitles = abbreviatedTitles,
    averageRating = averageRating,
    ratingFrequencies = ratingFrequencies,
    userCount = userCount,
    favoritesCount = favoritesCount,
    popularityRank = popularityRank,
    ratingRank = ratingRank,
    startDate = startDate,
    endDate = endDate,
    nextRelease = nextRelease,
    tba = tba,
    status = status,
    ageRating = ageRating,
    ageRatingGuide = ageRatingGuide,
    nsfw = nsfw,
    posterImage = posterImage?.toDBImage(),
    coverImage = coverImage?.toDBImage(),
    totalLength = totalLength,
    episodeCount = episodeCount,
    episodeLength = episodeLength,
    youtubeVideoId = youtubeVideoId,
    subtype = subtype,
)

fun LocalAnime.toAnime() = Anime(
    id = id,
    slug = slug,
    description = description,
    titles = titles,
    canonicalTitle = canonicalTitle,
    abbreviatedTitles = abbreviatedTitles,
    averageRating = averageRating,
    ratingFrequencies = ratingFrequencies,
    userCount = userCount,
    favoritesCount = favoritesCount,
    popularityRank = popularityRank,
    ratingRank = ratingRank,
    startDate = startDate,
    endDate = endDate,
    nextRelease = nextRelease,
    tba = tba,
    status = status,
    ageRating = ageRating,
    ageRatingGuide = ageRatingGuide,
    nsfw = nsfw,
    posterImage = posterImage?.toImage(),
    coverImage = coverImage?.toImage(),
    totalLength = totalLength,
    episodeCount = episodeCount,
    episodeLength = episodeLength,
    youtubeVideoId = youtubeVideoId,
    subtype = subtype,
    categories = null,
    animeProduction = null,
    streamingLinks = null,
    mediaRelationships = null
)
